/****************************************************************************/
// ceox_loadexampl.exe
//
// Win CE sample program. Loads the CEoX task "ceoxtask1.dll"
//
// (C)2007 SORCUS Computer GmbH
/****************************************************************************/
#include "stdafx.h"
#include "max_lib.h"
/****************************************************************************/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
   USHORT         usTask;
   MAXMODHND      hCpu;
   MAX_OS_INFO    rcOsInfo;
   MAX_ERROR      Error;
   MAX_PGM_TYPE   rcRtProgram;
   char           acRtFileName[MAX_PATH];
   HANDLE         hFile;

   max_init_lib(0);

   Error = max_connect_cpu(MAX_CEOX_HOST, MAX_AUTO_SLOT, 0, &rcOsInfo,  &hCpu);
	if (Error != ERR_OK)
	{
		printf("Error max_connect_cpu: 0x%04X\n", Error);
      return Error;
	}
	if(rcOsInfo.usType != MAX_WIN_CE_CEOX)
	{
		printf("Error CeoX not loaded\n");
      max_clear_error();
      max_exit_cpu(&hCpu);
      return Error;
	}
   printf("max_connect_cpu: OK\n");

   //find ceoxTask1.dll in Windows folder
   hFile = CreateFile(_T("\\Windows\\ceoxTask1.dll"), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
   if(hFile == INVALID_HANDLE_VALUE)
   {
      //find ceoxTask1.dll in onboardflash folder
      hFile = CreateFile(_T("\\onboardflash\\ceoxTask1.dll"), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
      if(hFile == INVALID_HANDLE_VALUE)
      {
         //find ceoxTask1.dll in onboardflash\SORCUS folder
         hFile = CreateFile(_T("\\onboardflash\\SORCUS\\ceoxTask1.dll"), GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
         if(hFile != INVALID_HANDLE_VALUE)
         {
            CloseHandle(hFile);
            if(!CopyFile(_T("\\onboardflash\\SORCUS\\ceoxTask1.dll"), _T("\\windows\\ceoxTask1.dll"), FALSE))
            {
               printf("Error Copy ceoxTask1.dll to windows folder (%u)\n", GetLastError());
               max_exit_cpu(&hCpu);
               return Error;
            }
         }
      }
      else
      {
         CloseHandle(hFile);
         if(!CopyFile(_T("\\onboardflash\\ceoxTask1.dll"), _T("\\windows\\ceoxTask1.dll"), FALSE))
         {
            printf("Error Copy ceoxTask1.dll to windows folder (%u)\n", GetLastError());
            max_exit_cpu(&hCpu);
            return Error;
         }
      }
   }
   else
   {
      CloseHandle(hFile);
   }

   //set data for rt program installation
   strcpy(acRtFileName, "\\Windows\\ceoxTask1.dll");
   rcRtProgram.szName = acRtFileName;
   rcRtProgram.usNo = 0x0065;
   rcRtProgram.usUsage = 0;
   rcRtProgram.usTask = 0x0012;
   rcRtProgram.usTaskType = MAX_NI_TASK;
   rcRtProgram.usLevel = 0;
   rcRtProgram.usIrq = 0;
   rcRtProgram.usFlags = MAX_CALL_AUTO_INIT | MAX_AUTO_ACTIVATE | MAX_TASKTYPE_BY_INSTALL | MAX_TASKNO_BY_INSTALL;
   rcRtProgram.ulDataSize = 0;

	Error = max_install_task(hCpu, &rcRtProgram, 0, &usTask);
	if (Error != 0)
	{
		printf("Error max_install_task: 0x%04X\n", Error);
	}
	else
	{
		printf("max_install_task: OK\n");
	}
   max_clear_error();
   max_exit_cpu(&hCpu);
	return Error;
}
